'
' Play three notes simultaniously to form a chord
'  	
        Device = 18F452	             
        XTAL = 20
                     
        Dim NOTE_1_COUNTER as Word SYSTEM  		' Determines when the pin for channel 1 is toggled                  
		Dim NOTE_1 as Word SYSTEM 				' Determines the pitch of the note
        Dim NOTE_2_COUNTER as Word SYSTEM    	' Determines when the pin for channel 2 is toggled               
		Dim NOTE_2 as Word SYSTEM 				' Determines the pitch of the note
        Dim NOTE_3_COUNTER as Word SYSTEM   	' Determines when the pin for channel 3 is toggled                
		Dim NOTE_3 as Word SYSTEM 				' Determines the pitch of the note
	
        Symbol TRIGGER = PORTB
                                                    
        Dim TIMER1 as TMR1L.Word				' Combine TMR1L/TMR1H into 16-bit variable TIMER1
                
        ON_INTERRUPT Goto NOTE_INT				' Point the hardware interrupt to the interrupt handler
        Delayms 100								' Wait for the PICmicro to stabilise
        ALL_DIGITAL = True						' Set PORTA and PORTE to all digital mode
        Low PORTB								' Discharge the capacitors before we start
        Low PORTA								' Make all of PORTA outputs to help discharge the capacitors
        Delayms 500								' Wait for them to discharge
        Goto MAIN_PROGRAM_LOOP					' Jump over the interrupt handling subroutine and the general subroutines
        
'----[INTERRUPT HANDLER TO PLAY THREE NOTES]--------------------------------------------------
NOTE_INT:
		TIMER1 = 65460							' Load TMR1 to increase the interrupt interval
        			        
        Inc NOTE_1_COUNTER    					' \  
        Inc NOTE_2_COUNTER						'  Increment each channel's toggle counter
        Inc NOTE_3_COUNTER						' /
                     	
' Note generator for channel 1              
        If NOTE_1_COUNTER >= NOTE_1 Then		' Is it time to toggle PORTA.0 ?
        	TRISA = TRISA ^ 1					' Yes. So XOR with 1 to toggle the pin
            Clear NOTE_1_COUNTER				' And reset the toggle counter
        Endif
' Note generator for channel 2
        If NOTE_2_COUNTER >= NOTE_2 Then		' Is it time to toggle PORTA.1 ?
        	TRISA = TRISA ^ 2					' Yes. So XOR with 2 to toggle the pin
            Clear NOTE_2_COUNTER				' And reset the toggle counter
        Endif
' Note generator for channel 3
        If NOTE_3_COUNTER >= NOTE_3 Then		' Is it time to toggle PORTA.2 ?
        	TRISA = TRISA ^ 4					' Yes. So XOR with 3 to toggle the pin
            Clear NOTE_3_COUNTER				' And reset the toggle counter
        Endif       
					
        Clear PIR1.0							' Clear TMR1 interrupt flag
        Retfie	FAST							' Return from the interrupt and restore WREG, BSR and STATUS
           
'----[MAIN PROGRAM CODE]-----------------------------------------------------------        
MAIN_PROGRAM_LOOP:
		     
        Input TRIGGER							' Remove any loading to the capacitors
        NOTE_1_COUNTER = 0						' \
        NOTE_2_COUNTER = 0						'   Clear note counters for all channels
        NOTE_3_COUNTER = 0						' / 
        INTCON = %11000000                     	' Enable global interrupts, TMR1 will trigger interrupts
		T1CON = %00000001                       ' Turn on Timer1, prescaler = 1:1
    	PIR1.0 = 0                              ' Clear TMR1 interrupt flag
    	PIE1.0 = 1                              ' Enable TMR1 as peripheral interrupt source   	
        

        NOTE_1 = 179							' Frequency value for channel 1 note
        NOTE_2 = 142							' Frequency value for channel 2 note
        NOTE_3 = 119							' Frequency value for channel 3 note
        High TRIGGER							' Start charging the capacitors
        Delayms 40								' Allow time for the capacitors to charge
       	Input TRIGGER							' Release the capacitors and let them discharge naturally       
        Stop									' Stop when notes are played
