' Program SINGLE_TABLE_MAKER.BAS
'
' Combine the three seperate tracks into a single table containing all three channels
'  	
        Include "PROTON18_20.INC"
                             
        Dim TICKS as Word
        Dim NOTE_POINTER as Word
        Dim CHANNEL_INFO as Byte
      	Dim PLAY_INFO as Byte
 		Dim CHANNEL_1_NOTE as Byte
        Dim CHANNEL1_TIME_ON as Word
        Dim TRACK_1_DATA as Word
        Dim CHANNEL_1_FINISHED as CHANNEL_INFO.0
        Dim CHANNEL_1_PREVIOUS_NOTE as Byte
		Dim CHANNEL_2_NOTE as Byte
        Dim CHANNEL2_TIME_ON as Word
        Dim TRACK_2_DATA as Word
        Dim CHANNEL_2_FINISHED as CHANNEL_INFO.1
        Dim CHANNEL_2_PREVIOUS_NOTE as Byte
		Dim CHANNEL_3_NOTE as Byte
        Dim CHANNEL3_TIME_ON as Word
        Dim TRACK_3_DATA as Word
        Dim CHANNEL_3_FINISHED as CHANNEL_INFO.2
        Dim CHANNEL_3_PREVIOUS_NOTE as Byte       
        Dim CHANNEL_1_PREVIOUS_TICK as Word
        Dim CHANNEL_2_PREVIOUS_TICK as Word
        Dim CHANNEL_3_PREVIOUS_TICK as Word      
        Dim CHANNEL_1_PLAYED as PLAY_INFO.0
        Dim CHANNEL_2_PLAYED as PLAY_INFO.1
        Dim CHANNEL_3_PLAYED as PLAY_INFO.2
        Dim TEMPO as Word
'------------------------------------------------      
        Delayms 400								' Wait for the PICmicro to stabilise
        Goto MAIN_PROGRAM_LOOP					' Jump over the interrupt handling subroutine and the general subroutines
           
'------------------------------------------------
' Read the music score data from lookup table TRACK_1
' The data format is time to play the note and the note's midi value
READ_NOTE_DATA_FOR_CHANNEL1:
        CHANNEL1_TIME_ON = Lread TRACK_1_DATA	' Read the NOTE_ON time (16-bits)
        TRACK_1_DATA = TRACK_1_DATA + 2			' Increment to next part
        CHANNEL_1_NOTE = Lread TRACK_1_DATA		' Read the NOTE frequency data (8-bits)       
        TRACK_1_DATA = TRACK_1_DATA + 2			' Increment to next part
        Return 
              
'------------------------------------------------
' Read the music score data from lookup table TRACK_2
' The data format is time to play the note and the note's midi value
READ_NOTE_DATA_FOR_CHANNEL2:
        CHANNEL2_TIME_ON = Lread TRACK_2_DATA	' Read the NOTE_ON time (16-bits)
        TRACK_2_DATA = TRACK_2_DATA + 2			' Increment to next part
        CHANNEL_2_NOTE = Lread TRACK_2_DATA		' Read the NOTE frequency data (8-bits)       
        TRACK_2_DATA = TRACK_2_DATA + 2			' Increment to next part
        Return 
        
'------------------------------------------------
' Read the music score data from lookup table TRACK_3
' The data format is time to play the note and the note's midi value
READ_NOTE_DATA_FOR_CHANNEL3:
        CHANNEL3_TIME_ON = Lread TRACK_3_DATA	' Read the NOTE_ON time (16-bits)
        TRACK_3_DATA = TRACK_3_DATA + 2			' Increment to next part
        CHANNEL_3_NOTE = Lread TRACK_3_DATA		' Read the NOTE frequency data (8-bits)
        TRACK_3_DATA = TRACK_3_DATA + 2			' Increment to next part
        Return 
       
'----[MAIN PROGRAM CODE]-----------------------------------------------------------------------------        
MAIN_PROGRAM_LOOP:
		
        Hrsout "ENTER TEMPO ",13
        Hrsin Dec TEMPO
        Hrsout 1,13
        Hrsout "TUNE_DATA:",13
        Hrsout "LDATA WORD ",Dec TEMPO," ' Tempo of tune",13
        
        CHANNEL_INFO = 0										' Clear all the channel finished flags
        TRACK_1_DATA = TRACK_1 									' Point TRACK_1_DATA to the music info for TRACK 1
        Gosub READ_NOTE_DATA_FOR_CHANNEL1						' Read the initial times and NOTE_1 data
        TRACK_2_DATA = TRACK_2 									' Point TRACK_2_DATA to the music info for TRACK 2
        Gosub READ_NOTE_DATA_FOR_CHANNEL2						' Read the initial times and note data
        TRACK_3_DATA = TRACK_3 									' Point TRACK_3_DATA to the music info for TRACK 3
        Gosub READ_NOTE_DATA_FOR_CHANNEL3						' Read the initial times and note data
        TICKS = 0												' Reset the ticks counter before we enter the loop
        While 1 = 1												' Create an infinite loop to play the music score                     
            
            PLAY_INFO = 0
            If TICKS = CHANNEL1_TIME_ON  Then					' Have we reached a NOTE_ON time for channel 1?
                CHANNEL_1_PREVIOUS_TICK = TICKS
                CHANNEL_1_PREVIOUS_NOTE = CHANNEL_1_NOTE 		' Save this note value for later                            
                If CHANNEL_1_NOTE <> 0 Then 					' Check if there is a note to play 
                	CHANNEL_1_PLAYED = 1
                	Gosub READ_NOTE_DATA_FOR_CHANNEL1			' Read the next time and note data                        	
            	Endif
            Else If CHANNEL1_TIME_ON = 0 Then					' Have we reached the end of TRACK 1 ?
            	CHANNEL_1_FINISHED = 1							' Yes. So signal that TRACK 1 is finished				
                CHANNEL_1_NOTE = 0								' Make sure no note is played
            Endif

            If TICKS = CHANNEL2_TIME_ON  Then					' Have we reached a NOTE_ON time for channel 2?
                CHANNEL_2_PREVIOUS_TICK = TICKS
                CHANNEL_2_PREVIOUS_NOTE = CHANNEL_2_NOTE		' Save this note value for later
                If CHANNEL_2_NOTE <> 0 Then 					' Check for channel 2 music data finished
                        CHANNEL_2_PLAYED = 1
                        Gosub READ_NOTE_DATA_FOR_CHANNEL2		' Read the next time and note data                        	
                Endif
            Else If CHANNEL2_TIME_ON = 0 Then					' Have we reached the end of TRACK 2 ?
            	CHANNEL_2_FINISHED = 1							' Yes. So signal that TRACK 2 is finished
                CHANNEL_2_NOTE = 0								' Make sure no note is played
            Endif

            If TICKS = CHANNEL3_TIME_ON  Then					' Have we reached a NOTE_ON time for channel 3?
                CHANNEL_3_PREVIOUS_TICK = TICKS
                CHANNEL_3_PREVIOUS_NOTE = CHANNEL_3_NOTE
                
                If CHANNEL_3_NOTE <> 0 Then 					' Check for channel 3 music data finished    	                       	
                    CHANNEL_3_PLAYED = 1
                    Gosub READ_NOTE_DATA_FOR_CHANNEL3			' Read the time and note data                        	
                Endif
            Else If CHANNEL3_TIME_ON = 0 Then					' Have we reached the end of TRACK 3 ?
            	CHANNEL_3_FINISHED = 1							' Yes. So signal that TRACK 3 is finished
                CHANNEL_3_NOTE = 0								' Make sure no note is played
            Endif

            Select PLAY_INFO
                Case 1    
                    Hrsout "LDATA WORD ",Dec CHANNEL_1_PREVIOUS_TICK," , BYTE ",Dec CHANNEL_1_PREVIOUS_NOTE," , BYTE 00 , BYTE 00",13
                Case 2  
                    Hrsout "LDATA WORD ",Dec CHANNEL_2_PREVIOUS_TICK," , BYTE 00 , BYTE ",Dec CHANNEL_2_PREVIOUS_NOTE," , BYTE 00",13
                Case 3    
                    Hrsout "LDATA WORD ",Dec CHANNEL_1_PREVIOUS_TICK," , BYTE ",Dec CHANNEL_1_PREVIOUS_NOTE," , BYTE ",Dec CHANNEL_2_PREVIOUS_NOTE," , BYTE 00",13
                Case 4    
                    Hrsout "LDATA WORD ",Dec CHANNEL_3_PREVIOUS_TICK," , BYTE 00 , BYTE 00 , BYTE ",Dec CHANNEL_3_PREVIOUS_NOTE,13
                Case 5    
                    Hrsout "LDATA WORD ",Dec CHANNEL_1_PREVIOUS_TICK," , BYTE ",Dec CHANNEL_1_PREVIOUS_NOTE," , BYTE 00 , BYTE ",Dec CHANNEL_3_PREVIOUS_NOTE,13
                Case 6   
                    Hrsout "LDATA WORD ",Dec CHANNEL_2_PREVIOUS_TICK," , BYTE 00 , BYTE ",Dec CHANNEL_2_PREVIOUS_NOTE," , BYTE ",Dec CHANNEL_3_PREVIOUS_NOTE,13
                Case 7 
                	Hrsout "LDATA WORD ",Dec CHANNEL_1_PREVIOUS_TICK," , BYTE ",Dec CHANNEL_1_PREVIOUS_NOTE," , BYTE ",Dec CHANNEL_2_PREVIOUS_NOTE," , BYTE ",Dec CHANNEL_3_PREVIOUS_NOTE,13                                      
            EndSelect
            
            If CHANNEL_INFO = %00000111 Then Break				' Exit the loop if all the channels are finished
                      
            Inc TICKS											' Increment the TICKS counter
        Wend
        Hrsout "LDATA WORD 00000 , BYTE 00 , BYTE 00 , BYTE 00",13
        Stop
'----------------------------------------------------------------
        
REMINDERS = OFF 												' Disable any reminders after this point              
  

'----------------------------------------------------------------
' Load the music scores

        Include "MERRY CHRISTMAS.BAS"	

        